/*
University of Sao Paulo - Institute of Mathematics and Computer Science ( ICMC - USP)
Computer Graphics - SCC 0250
Developer (PAE): Vinicius R. P. Borges
Profa: Maria Cristina Ferreira de Oliveira

CODE 1 - OpenGL Basics

Para compilar este codigo, execute no terminal do Linux - To compile this code, type the following command

# gcc helloworld.c  -lX11 -lglut -lGL -lGLU -lm -o hello

Para executar o codigo, digite:

# ./hello

*/

//Bibliotecas - Libraries

// Biblioteca de entrada e saida padrão de dados
#include <stdio.h>
// Biblioteca GL: Contém as funções padrões do OpenGl
#include <GL/gl.h>
// Biblioteca GLU : Rotinas que utilizam os comandos OpenGL de baixo nível para executar tarefas
#include <GL/glu.h>
// Biblioteca GLUT : Criação de janelas e tratamento de eventos de forma independente do sistema operacional
#include <GL/glut.h>

// Armazena valor inteiro que identifica uma janela
int window;

//Funcao que prepara a janela onde a cena grafica sera desenhada
void InitGL(int Width, int Height) {
  
     // Ajusta a cor de fundo para branco
     glClearColor(1.0f,1.0f,1.0f,0.0f);
     
     // Carrega a matriz de projecao
     glMatrixMode(GL_PROJECTION);
     
     // Projecao ortogonal que mapeia  objetos da coordenada
     // do mundo para coordenadas da tela
     gluOrtho2D(0.0,100.0,0.0,100.0);
}

//Funcao que desenha a cena grafica na tela
void DrawGLScene() {
  
    // Limpa a tela e o Depth Buffer
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

     // Desenha objetos com a cor verde
     glColor3f(0.0f,1.0f,0.0f);
     
     // Desenha um quadrado
     glBegin(GL_POLYGON);
            glVertex2i(60,60);
            glVertex2i(60,70);
            glVertex2i(70,70);
     glEnd();
     
     // Processa as  rotinas do OpenGL o mais rapido possivel
     glFlush();
}

main(int argc, char *argv[])
{
    glutInit(&argc, argv);

    //Simple buffer
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);

    //Coordenada inicial da janela
    glutInitWindowPosition(0, 0);

    //Janela com 640x480
    glutInitWindowSize(640, 480);

    //Nome da Janela
    window = glutCreateWindow("Simple Example using OpenGL");

    //Funcao que prepara a cena grafica na janela com dimensoes 640 x 480
    InitGL(640, 480);
    
    //Desenha a cena grafica na tela
    glutDisplayFunc(DrawGLScene);

    //Loop de atualizacao da tela
    glutMainLoop();

    return 0;
}
